<template>
  <base-card>
    <base-button
      @click="setSelectedTab('stored-resource')"
      option="Stored Resource"
      :mode="isSelected('stored-resource') ? null : 'flat'"
      >Stored Resource</base-button
    >
    <base-button
      @click="setSelectedTab('add-resource')"
      :mode="isSelected('add-resource') ? null : 'flat'"
      option="Add Resource"
    ></base-button>
  </base-card>
  <keep-alive>
    <component :is="selectedTab"> </component>
  </keep-alive>
</template>

<script>
import StoredResource from './StoredResource.vue';
import AddResource from './AddResource.vue';

export default {
  components: {
    StoredResource,
    AddResource
  },
  data: function() {
    return {
      selectedTab: 'stored-resource',
      storedResources: [
        {
          id: '0001',
          title: 'Official Guide',
          description: 'The Official VueJS documentation',
          link: 'https://vuejs.org'
        },
        {
          id: '0002',
          title: 'Google',
          description: 'Learn to Google',
          link: 'https://www.google.co.in'
        }
      ]
    };
  },
  provide: function() {
    return {
      resources: this.storedResources,
      addResource: this.addResource,
      removeResource: this.removeResource
    };
  },
  methods: {
    setSelectedTab: function(tab) {
      this.selectedTab = tab;
    },
    isSelected(tab) {
      return this.selectedTab === tab;
    },
    addResource: function(title, description, link) {
      const resource = {
        id: new Date().toISOString(),
        title,
        description,
        link
      };
      this.storedResources.unshift(resource);
      this.selectedTab = 'stored-resource';
    },
    removeResource: function(resId) {
      const index = this.storedResources.findIndex(res => res.id === resId);
      this.storedResources.splice(index, 1);
    }
  }
};
</script>
